#include <iostream>
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct str{
    ll sum;
    ll mx;
};
vector <str> tree;
vector <int> tree1;
vector <str> a;
vector <int> a1;
vector <str> p;
int mx(int x, int y) {
    if (x == -1) {
        return y;
    }
    if (y == -1) {
        return x;
    }
    if (a[x].sum > a[y].sum) {
        return x;
    }
    return y;
}
str f(str a, str b) {
    str c = {a.sum + b.sum, mx(a.mx, b.mx)};
    return(c);
}
void push(int i, int l, int r) {
    if (p[i].sum == 0) {
        return;
    }
    str c = {p[i].sum * (r - l), mx(p[i].mx, tree[i].mx)};
    if (r - l == 1) {
        tree[i] = (c);
        p[i] = {0, -1};
        return;
    }
    int m = (l + r) / 2;
    tree[i] = (c);
    p[i * 2] = {max(p[i * 2].sum, p[i].sum), mx(p[i].mx, p[i * 2].mx)};
    p[i * 2 + 1] = {max(p[i * 2 + 1].sum, p[i].sum),  mx(p[i].mx, p[i * 2 + 1].mx)};
    p[i] = {0, -1};
}
void build (int n, int i, int l, int r) {
    if (r - l == 1) {
        tree[i] = a[l];
        return;
    }
    int m = (l + r) / 2;
    push(i, l, r);
    build(n, i * 2, l, m);
    build(n, i * 2 + 1, m, r);
    tree[i] = f(tree[i * 2] ,tree[i * 2 + 1]);
    return;
}
void upd(int n, int i, int l, int r, int ql, int qr, str x) {
    if (ql <= l && r <= qr) {
        p[i] = {max(x.sum, p[i].sum), mx(p[i].mx, x.mx)};
        push(i, l, r);
        return;
    }
    if (ql >= r || l >= qr) {
        return;
    }
    int m = (l + r) / 2;
    push(i, l, r);
    upd(n, i * 2, l, m, ql, qr, x);
    upd(n, i * 2 + 1, m, r, ql, qr, x);
    tree[i] = f(tree[i * 2] ,tree[i * 2 + 1]);
    return;
}
str get(int n, int i, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[i];
    }
    if (ql >= r || l >= qr) {
        return {0, -1};
    }
    int m = (l + r) / 2;
    push(i, l, r);
    return f(get(n, i * 2 , l, m, ql, qr),get(n, i * 2 + 1, m, r, ql, qr));
}
int getmx(int n, int i, int l, int r, int ql, int qr, int x) {
    if (ql >= r || l >= qr) {
        return -1;
    }
    if (ql <= l && r <= qr && a[tree[i].mx].sum < x) {
        return -1;
    }
    if (r - l == 1) {
        if (a[tree[i].mx].sum >= x) {
            return l;
        }
        return -1;
    }
    int m = (l + r) / 2;
    int y = -1;
    if (x <= a[tree[i * 2 + 1].mx].sum) {
        y = getmx(n, i * 2 + 1, r, m, ql, qr, x);
    }
    if (y == -1) {
        y = getmx(n, i * 2, l, m, ql, qr, x);
    }
    return y;
}
void build1 (int n, int i, int l, int r) {
    if (r - l == 1) {
        tree1[i] = a1[l];
        return;
    }
    int m = (l + r) / 2;
    build1(n, i * 2, l, m);
    build1(n, i * 2 + 1, m, r);
    tree1[i] = tree1[i * 2] + tree1[i * 2 + 1];
    return;
}
void upd1(int n, int i, int l, int r, int ind, int x) {
    if (r - l == 1) {
        tree1[i] = x;
        return;
    }
    int m = (l + r) / 2;
    if (m > ind) {
        upd1(n, i * 2, l, m, ind, x);
    } else {
        upd1(n, i * 2 + 1, m, r, ind, x);
    }
    tree1[i] = tree1[i * 2] + tree1[i * 2 + 1];
    return;
}
int get1(int n, int i, int l, int r, int k) {
    if (r - l == 1){
        return l;
    }
    int m = (l + r) / 2;
    if (k <= tree1[i * 2]) {
        return get1(n, i * 2, l, m, k);
    } else {
        return get1(n, i * 2 + 1, m, r, k - tree1[i * 2]);
    }
}
int main()
{
    int n;
    cin >> n;
    a.resize(n);
    a1.resize(n + 1, 1);
    p.resize(n * 4, {0, -1});
    tree.resize(n * 4);
    tree1.resize(n * 4 + 4);
    vector <int> pr(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a1[i];
        a[i] = {a1[i], i};
        pr[i + 1] = pr[i] + a1[i];
        a1[i] = 1;
    }
    build(n, 1, 0, n);
    build1(n + 1, 1, 0, n + 1);
    for (int i = 0; i < n - 1; i++) {
        int q;
        cin >> q;
        int indm = get1(n + 1, 1, 0, n + 1, q);
        int indl = get1(n + 1, 1, 0, n + 1, q - 1);
        int indr = get1(n + 1, 1, 0, n + 1, q + 1);
        if (q - 1 == 0) {
            indl = 0;
        } else {
            indl++;
        }
        upd1(n + 1, 1, 0, n + 1, indm, 0);
        str x;
        str y = get(n, 1, 0, n, indm + 1, indr + 1);
        int z = getmx(n, 1, 0, n, indl, indm + 1, y.mx);
        x.mx = z;
        cout << z << endl;
        if (z == -1){
            x = get(n, 1, 0, n, indl, indm + 1);
        }
        int mn = min(a[x.mx].sum, a[y.mx].sum);
        if (y.mx - x.mx + 1 >= 3) {
            upd(n, 1, 0, n, x.mx + 1, y.mx, {mn, -1});
        }

        cout << get(n, 1, 0, n, indl, indr + 1).sum /*- pr[indr + 1] + pr[indl]*/<< endl;
    }
    return 0;
}
